#define _GNU_SOURCE
#include <dlfcn.h>
#include <stdio.h>
#include <linux/hdreg.h>
#include <string.h>

static struct hd_driveid fake_hd;

int (*o_ioctl)(int fd, long unsigned int r, char *p) = 0;

int ioctl(int fd, long unsigned int r, char *p) {
	if (o_ioctl == 0) {
		o_ioctl = dlsym(RTLD_NEXT, "ioctl");
		// https://docs.huihoo.com/doxygen/linux/kernel/3.7/structhd__driveid.html
		snprintf((char*)&fake_hd.model, 40, "FakeModel");
		snprintf((char*)&fake_hd.serial_no, 20, "123456789");
	}

	if (r == HDIO_GET_IDENTITY) {
		memcpy(p, &fake_hd, sizeof(struct hd_driveid));
		return 0;
	}

	return o_ioctl(fd, r, p);
}
